/*
VERSION: 4.0
*/
func_help = undefined;

function serverRequest(body) {
	return new Promise(function(resolve, reject) {
		var xhr = new XMLHttpRequest();
		xhr.open('POST', '/sys/console.wcgp');
		xhr.onloadend = function() {
			if (this.status == 200) {
				resolve(JSON.parse(xhr.response));
			} else {
				reject({
					status: this.status,
					statusText: xhr.response
				});
			}
		}
		xhr.onerror = function () {
			reject({
				status: this.status,
				statusText: xhr.response
			});
		}
		xhr.send(body);
	})
}

function getDomains() {
	return new Promise(function(resolve, reject) {
		json = JSON.stringify({ 
		type : "getDomains"
		})

		serverRequest(json)
		 .then(domains => {
		 	var domainList = document.getElementById("domainItems");

			for (var i=domains.length-1; i>=0 ; i--) {
				var wrapper = document.createElement("div");
				var inp = document.createElement("input");
				inp.id = domains[i];
				inp.value = domains[i];
				inp.type = "radio";
				inp.name = "domain_select";

				if (i==0) {
					inp.checked = "checked";
				}

				var label = document.createElement("label");
				label.htmlFor = domains[i];
				label.innerText = domains[i];

				var check = document.createElement("i");
				check.classList.add("fas", "fa-check");

				label.appendChild(check);
				wrapper.appendChild(inp);
				wrapper.appendChild(label);

				wrapper.firstChild.addEventListener('change', changeDomain);
				wrapper.firstChild.addEventListener('click', makeSelectActive);

				domainList.insertBefore(wrapper, domainList.firstChild);
			}
			resolve();
		})
		 .catch(error => {
		 	console.log(error);
		 	reject();
		 })
	})
}

function getAccounts(){
	return new Promise(function(resolve, reject) {
		json = JSON.stringify({ 
			type : "getUsers",
			mask : document.getElementById("searchField").value || null,
			domain : document.querySelector('input[name = "domain_select"]:checked').value || "*",
		})

		serverRequest(json)
		 .then(body => {
			body.sort();
			resolve(body);
		 })
		 .catch(error => {
		 	console.log(error);
		 	reject(error);
		 })
	})
}

function getGroups() {
	return new	Promise(function(resolve, reject) {
		json = JSON.stringify({ 
			type : "getGroups",
			mask : document.getElementById("searchField").value || document.getElementById('groupsSearchField').value || '',
			domain : document.querySelector('input[name="domain_select"]:checked').value || "*",
		})

		serverRequest(json)
		 .then(groups => {
			resolve(groups.sort());
		 })
		 .catch(error => {
		 	console.log(error);
		 })
	})
}

function getGroupMembers(groupName) {
	return new	Promise(function(resolve, reject) {
		json = JSON.stringify({ 
			type : "getGroupMembers",
			groupName : groupName || "*",
		})

		serverRequest(json)
		 .then(members => {
			resolve(members);
		 })
		 .catch(error => {
		 	console.log(error);
		 })
	})
}

function filterGroups(input) { //edit
	var groups = document.querySelectorAll('button[name="groups"]');

	for (var i = groups.length - 1; i >= 0; i--) {
		if (groups[i].id.startsWith(input)) {
			groups[i].parentNode.className = '';
		}
		else {
			groups[i].parentNode.className = 'content';
		}
	}
}

function showPopup() {
	document.getElementById('popup').style.display = 'block';
}

function hidePopup(e) {
	var p = document.getElementById('popup');
	try {
		if (p.children[0].contains(e.target)) {
			return
		}
	} catch {}

  	p.style.display = 'none';
  	document.getElementById('groupsSearchField').value = '';
  	document.getElementById('groupsSearchResultsFooter').style.display = 'none';
  	document.getElementById('groupsSearchResultsLabels').replaceChildren();
}

function popUpGroups() {
	let mask = document.getElementById('groupsSearchField').value;

	getGroups()
	 .then(groups => {
	 	var container = document.getElementById('groupsSearchResultsLabels');
		var btn = document.getElementById("addGroupsSearchResults");
		var counter = document.getElementById("groupsSearchResultsAmount");
		var gsr = document.getElementById("groupsSearchResults");
		document.getElementById('groupsSearchResultsFooter').style.display = 'flex';
		
		while (container.firstChild) {
		    container.firstChild.remove()
		}

		counter.innerText = "found: " + groups.length.toString();

		gsr.style.display = "flex";

		btn.innerText = 'Add All';
		
		if (groups.length == 0) {
			btn.disabled = true;
			return
		}

		btn.disabled = false;

		for (var i = groups.length - 1; i >= 0; i--) {
			var checkbox = document.createElement("input");
			checkbox.type = "checkbox";
			checkbox.name = "accounts";
			checkbox.value = groups[i];
			checkbox.id = groups[i]+"cbx";

			var label = document.createElement('label')
			label.htmlFor = groups[i]+"cbx";
			label.innerText = groups[i];
			
			container.insertBefore(label, container.firstChild);
			container.insertBefore(checkbox, container.firstChild);

			container.children[0].addEventListener('click', function(){
				count = container.querySelectorAll('input[type="checkbox"]:checked').length;
				if (count > 0) {
					counter.innerText = 'selected: ' + count;
					btn.innerText = 'Add Selected';
				}
				else {
					counter.innerText = "found: " + groups.length.toString();
					btn.innerText = 'Add All';
				}
			});
		}
	 });
}

function openlist(elem) {
  var funcList = elem.parentNode.parentNode.getElementsByClassName("content")[0];
  var arrow = elem.getElementsByTagName('i')[0];

  if (funcList.style.maxHeight) {
		arrow.className = 'far fa-angle-down angleIcon';
	}
   else{
		arrow.className = 'far fa-angle-up angleIcon';
	};
}

function changeDomain() {
	clearAccounts(true);
	clearTags();
	getGroups().then(groups => createGroupsList(groups));
}

function createGroupsList(groups) {
	if (groups === undefined) {
		return;
	}

	container = document.getElementById('groups');
	for (var i = groups.length - 1; i >= 0; i--) {
		var wrapper = document.createElement('div');
		let groupName = groups[i];

		var btn = document.createElement('button');
			btn.id = groupName;
			btn.name = "groups";
		
		btn.onclick = function() {
			getGroupMembers(groupName).then(accs => {
				addAccounts(accs)
				addTag(groupName, accs)
			});
		};

		var label = document.createElement('label');
			label.htmlFor = groupName;
			label.innerText = groupName;

		wrapper.appendChild(btn);
		wrapper.appendChild(label);

		container.insertBefore(wrapper, container.children[1]);
	}
	if (i > 3) {
		container.lastChild.hidden = false;	
	}
}

function createAccListTile(accs){
	var container = document.getElementById("searchResultsLabels");
	let btn = document.getElementById("addSearchResults");
	let counter = document.getElementById("searchResultsAmount");
	while (container.firstChild) {
	    container.firstChild.remove()
	}

	counter.innerText = "found: " + accs.length.toString();

	var sr = document.getElementById("searchResults");
	sr.style.display = "flex";
	sr.focus();

	btn.innerText = 'Add All';
	
	if (accs.length == 0) {
		btn.disabled = true;
		return
	}

	btn.disabled = false;

	for (var i = accs.length - 1; i >= 0; i--) {
		var checkbox = document.createElement("input");
		checkbox.type = "checkbox";
		checkbox.name = "accounts";
		checkbox.value = accs[i];
		checkbox.id = accs[i]+"cbx";

		var label = document.createElement('label')
		label.htmlFor = accs[i]+"cbx";
		label.innerText = accs[i];
		
		container.insertBefore(label, container.firstChild);
		container.insertBefore(checkbox, container.firstChild);

		container.children[0].addEventListener('click', function(){
			count = container.querySelectorAll('input[type="checkbox"]:checked').length;

			if (count > 0) {
				counter.innerText = 'selected: ' + count;
				btn.innerText = 'Add Selected';
			}
			else {
				counter.innerText = "found: " + accs.length.toString();
				btn.innerText = 'Add All';
			}
		});
	}
}

function renderAccountsList(){
	if (document.querySelector("input[name='acc_search_filter']:checked").id == 'byGroupFilter') {
		getGroups()
		 .then(groups => {
		 	createAccListTile(groups)
		 })
	}

	else{
		getAccounts()
		 .then(accs => createAccListTile(accs));
	}
}

function hideAccountSearchResults() {
	document.getElementById("searchResults").style.display = "none";
	document.getElementById("searchField").value = null
	setTimeout(function() {
		document.getElementById("searchResultsLabels").replaceChildren();
	}, 2000)
}

function callContextMenu(pevent, el, event) {
	var s = document.getElementById('selectedAccMngmt');
	s.style.display = 'flex';

	var elRect = el.getBoundingClientRect();
	s.style.top = elRect.y + 'px';
	if (elRect.x - 534 + elRect.width + 186> el.parentNode.offsetWidth ) {
		s.style.left = elRect.x - 186 + 'px';
	}

	else{
		s.style.left = elRect.x + elRect.width + 'px';
	}
	
	event.preventDefault();
}

function addAccounts(accounts) {
	var accField = document.getElementById("accountsList");

	for (var i = accounts.length - 1; i >= 0; i--) {
		account = accounts[i].value || accounts[i];
		
		if (document.getElementById(account) != null) {
			continue
		}

		var container = document.createElement('div');
			container.classList.add("accountTile");

		container.addEventListener('contextmenu', callContextMenu.bind(event, event, container));

		container.addEventListener('click', function() {
			if (document.getElementById("runBtn").className != 'normalRun') {
				renderRunBtn();
			}
		});

		var button = document.createElement('button');
			button.classList.add("far", "fa-minus", "deleteAccBtn");

		button.addEventListener('click', function() {
			return function() {
				tile = this.parentNode
				accList = tile.parentNode
				if (accList.children.length == 1) {
					clearAccounts(true);
					clearTags();
				}
				else {
					accList.removeChild(tile);
				}
			}
		}());

		var checkbox = document.createElement("input");
			checkbox.type = "checkbox";
			checkbox.name = "selectedAccounts";
			checkbox.value = account;
			checkbox.id = account;

		var label = document.createElement('label')
			label.htmlFor = account;
			label.innerText = account;

		container.appendChild(checkbox);
		container.appendChild(label);
		container.appendChild(button);
		accField.insertBefore(container, accField.firstChild);
	}

	hideAccountSearchResults();
	b = document.getElementById('addAccountBtns');
	b.style.display = 'none';
	l = document.getElementById('accountsList');
	l.style.display = 'flex';
}

function addSelectedAccounts(obj){
	if (obj.innerText == 'Add Selected') { //selected or all
		var accounts = document.querySelectorAll('input[name="accounts"]:checked');
	}
	else {
		var accounts = document.querySelectorAll('input[name="accounts"]');
	}
	groupName = document.getElementById("searchField").value || 'Selected';

	if (document.querySelector("input[name='acc_search_filter']:checked").id == 'byGroupFilter' || obj.id == "addGroupsSearchResults") {
		var accsList = []
		for (var i = accounts.length - 1; i >= 0; i--) {
			let groupName = accounts[i].value;
			getGroupMembers(groupName)
			 .then(accs => {
				accsList = accsList.concat(accs);
	 		 	if (i == -1) {
				 	addAccounts(accs);
					addTag(groupName, accs);
	 		 	}
			 });
		}
	}
	else {
		addAccounts(accounts);
		addTag(groupName, accounts);
	}
}

function addAllDomainUsers() {
	getAccounts().then(accs => {
		addAccounts(accs);
		addTag(null, accs);
	});
	clearAccounts(true);
}

function clearAccounts(all) {
	var accs = document.getElementById("accountsList");
	if (all) {
		accs.replaceChildren();
	}
	else {
		var accsToDelete = document.querySelectorAll('input[name="selectedAccounts"]:checked');
		for (var i = accsToDelete.length - 1; i >= 0; i--) {
			accs.removeChild(accsToDelete[i].parentNode);
		}
	}
	if (accs.children.length == 0) {
		clearTags();
		accs.style.display = "none";
		document.getElementById("addAccountBtns").style.display = "flex";
	}
}

function addTag(groupName, accounts){
	var tagField = document.getElementById("groupsTile");
	if (tagField.children.length > 6) {
		alert('Max amount of groups added');
		return
	}

	var tag = document.createElement('div');
		tag.classList.add("tag");

	var name = document.createElement('span');
		name.innerText = groupName || 'All';

	var button = document.createElement('button');
		button.classList.add("far", "fa-times-circle", "btnIcon");

	button.addEventListener('click', function() {
		for (var i = accounts.length - 1; i >= 0; i--) {
			id = accounts[i].value || accounts[i];
			try {
				document.getElementById(id).parentNode.remove()
			} catch {}
		}
		tagField.removeChild(tag);
		if (tagField.children.length == 0) {
			document.getElementById("accountsList").style.display = "none";
			document.getElementById("addAccountBtns").style.display = "flex";
		}
	})

	tag.appendChild(name);
	tag.appendChild(button);
	tagField.appendChild(tag);
}

function clearTags() {
	document.getElementById('groupsTile').replaceChildren();
}

function downloadFile(body, name) {
	var file = new Blob([body], {type: 'text/plain'});
	var a = document.createElement("a")
	a.href = URL.createObjectURL(file);
	a.download = name;
	a.click();
}

function downloadReport(reportBody) {
	var body = "";
	for (var i = reportBody.length - 1; i >= 0; i--) {
		body = reportBody[i].result + body;
	}

	downloadFile(body, 'CGP Report.txt');

	var message = document.createElement("span")
	message.innerText = "Report was created and downloaded";
	message.classList.add("resultAccountName");

	document.getElementById("results").appendChild(message);
}

function downloadAccountsList() {
	var domain = document.querySelector('input[name="domain_select"]:checked').value;
	var accs = document.querySelectorAll('input[name="selectedAccounts"]:checked');
	var body = '';
	for (var i = accs.length - 1; i >= 0; i--) {
		body = accs[i].value + "@" + domain + "\n" + body;
	}
	
	downloadFile(body, 'Accounts List.txt');
}

function downloadFuncResults() {
	var accs = document.querySelectorAll('span[class="resultAccountName"]');
	var result = document.querySelectorAll('span[class="resultMessage"]');
	var body = '';
	for (var i = accs.length - 1; i >= 0; i--) {
		body = accs[i].textContent + "\t" + result[i].textContent + "\n" + body;
	}
	downloadFile(body, 'Function result.txt');
}

function loadFunctions(){
	var domainList = document.getElementById("funcContainer");

	Object.entries(func_help).forEach(([category, function_list]) => {
		var wrapper = document.createElement("ul");
		wrapper.classList.add("drop-down-menu");
		
		var container = document.createElement("li");
		container.classList.add("list");

		var category_wrapper = document.createElement("div");
		category_wrapper.classList.add("collapsible");

		var angle = document.createElement("i");
		angle.classList.add("far", "fa-angle-down", "angleIcon");

		var func_list = document.createElement("ul");
		func_list.classList.add("child", "content");
		
		var cat_name = document.createElement("span");
		cat_name.innerText = category;

		for (var i=function_list.length-1;i>=0; i--) {
			(function () {
				short_name = Object.keys(function_list[i])[0];

				var li = document.createElement("li");
				var input = document.createElement("input");
				input.id = short_name;
				input.value = short_name;
				input.type = "radio";
				input.name = "func_select";

				var label = document.createElement("label");
				label.htmlFor = short_name;
				label.innerText = function_list[i][short_name]["name"];

				li.appendChild(input);
				li.appendChild(label);
				
				var h = function_list[i][short_name]["help"];
				var p = function_list[i][short_name]["params"];

				li.children[1].addEventListener('click', function() {
					chooseFunction(li, h, p);
				});
				
				func_list.insertBefore(li, func_list.firstChild);
			}());

		}

		var spacer = document.createElement("div");
		spacer.classList.add("spacer");
		func_list.appendChild(spacer);
		
		category_wrapper.appendChild(cat_name);
		category_wrapper.appendChild(angle);

		container.appendChild(category_wrapper);
		container.appendChild(func_list);
		wrapper.appendChild(container);
		wrapper.children[0].children[0].addEventListener('click', function(){
			openlist(wrapper.children[0].children[0]);
		});

		domainList.appendChild(wrapper);
	});
}

function chooseFunction(elem, help, params) {
  e = document.getElementById("funcName")
  name = elem.getElementsByTagName("label")[0].innerText
  func = elem.getElementsByTagName("input")[0].value
  e.innerText = name;

  e = document.getElementById("funcHelp").getElementsByClassName("helpText")[0];
  e.innerText = help;

  showParams(params);
  renderRunBtn();
}

function showParams(params) {
	paramBlock = document.getElementById("params");
	paramBlock.style.background = "#FFFFFF";

	while (paramBlock.firstChild) {
	    paramBlock.firstChild.remove()
	}

	if (params.length == 0) {
		var container = document.createElement("div");
		container.classList.add("message");
		var msg = document.createElement("span");
		msg.innerText = "This Function has no parameters";
		container.appendChild(msg);
		paramBlock.appendChild(container);
		paramBlock.style.background = "none";
		return;
	}
	for (var i=params.length-1; i>=0; i--) {
		var container = document.createElement("div");
		container.classList.add("paramSpacing");
		//edit
		if(params[i] == "Rights"){
			var rights = ["Read", "Write", "Admin", "None"];
	
			var selectList = document.createElement("div");
			selectList.id = "rightsSelect";
			selectList.classList.add("select", "cat-select");

			var icon = document.createElement("i");
			icon.classList.add("fas", "fa-caret-down", "caret");
			icon.style.top	= "8px";
			
			var textDiv = document.createElement("div");
			textDiv.classList.add("textBlock");
			
			var span = document.createElement("span");
			span.innerText = "Chose rigths";
			textDiv.appendChild(span);

			var selectDiv = document.createElement("div");
			selectDiv.classList.add("select-items");

			for (var j=rights.length-1; j>=0; j--) {
				var wrapper = document.createElement("div");

				var input = document.createElement("input");
				input.id = rights[j];
				input.type = "radio";
				input.name = "Rights";
				input.value = rights[j];
				if (j==0){
					input.checked = "checked";
				}

				var label =  document.createElement("label");
				label.htmlFor = rights[j];
				label.style.height = "28px";

				var tick = document.createElement("i");
				tick.classList.add("fas", "fa-check");
				label.appendChild(tick);
				label.appendChild(document.createTextNode(rights[j]))

				input.addEventListener('click', makeSelectActive);
				wrapper.appendChild(input);
				wrapper.appendChild(label);
				selectDiv.insertBefore(wrapper, selectDiv.firstChild);
			}

			selectList.appendChild(icon);
			selectList.appendChild(textDiv);
			selectList.appendChild(selectDiv);
			container.appendChild(selectList);
		}
		else if(params[i] == "Subscribe" || params[i] ==  "Download"){			
			var checkbox = document.createElement("input");
			checkbox.type = "checkbox";
			checkbox.name = params[i];
			checkbox.id = params[i];

			var label = document.createElement('label')
			label.htmlFor = params[i];
			label.innerText = params[i];

			container.appendChild(checkbox);
			container.appendChild(label);
		}

		else if(params[i] == "Directory"){
			var radio_var = ["Server", "Domain"];

			for (var j=radio_var.length-1; j>=0; j--) {
				var radio = document.createElement("input");
				radio.id = "directory" + radio_var[j];
				radio.type = "radio";
				radio.name = params[i];
				radio.value = radio_var[j];

				var label = document.createElement("label");
				label.htmlFor = "directory" + radio_var[j];
				label.innerText = radio_var[j];

				container.appendChild(radio);
				container.appendChild(label);
			}

			container.firstChild.checked = true;
		}

		else{
			var input = document.createElement("input");
			input.id = params[i];
			input.type = "text";
			input.name = params[i];
			input.placeholder = params[i];
			input.style.border = "1px solid #CECECE";

			container.appendChild(input);
		}

		container.addEventListener('focusout', function() {
			renderRunBtn();
		});

		var err_block = document.createElement("div")
		container.appendChild(err_block);
		paramBlock.insertBefore(container, paramBlock.firstChild);
	}
}

function funcRun(){
	var type = "function";
	
	var domain = document.querySelector('input[name="domain_select"]:checked').value;
	var funcName = document.querySelector('input[name="func_select"]:checked').value;
	var params = document.getElementById('params').querySelectorAll('input');
	var rawAccounts = document.querySelectorAll('input[name="selectedAccounts"]');

	accounts = [];
	
	for (var i = rawAccounts.length - 1; i >= 0; i--) {
		accounts.unshift(rawAccounts[i].value + "@" + domain);
	}
		
	
	var id = window.location.pathname.split('/');
		id = id[2];

	json = { 
		type : type, 
		functionName : funcName,
		accounts : accounts, 
		id : id,
		params : ({
			domain : domain
		})	
	};
		
	for (var i = params.length - 1; i >= 0; i--) {
		if (params[i].type == "text") {
			json.params[params[i].name] = params[i].value;
		}
		else if (params[i].type == "radio" && params[i].checked) {
			json.params[params[i].name] = params[i].value
		}
		else {
			json.params[params[i].name] = params[i].checked
		}
	}

	document.getElementById("results").replaceChildren();

	json = JSON.stringify(json)
 	
	serverRequest(json)
	 .then(body => {
	 	var r = document.getElementById("results");
		if(body.type == "document"){ //check header
			downloadReport(body.result);
		}
		
		if(body.message == "Success" || body.message == "Mass operation executed"){
			var accs = body.result;
			renderRunBtn(true)
			for (var i = accs.length - 1; i >= 0; i--) {
				var accountName = document.createElement("span")
				var message = document.createElement("span")

				accountName.innerText = accs[i].account;
				accountName.classList.add("resultAccountName");

				message.innerHTML = makeBold(accs[i].result);
				message.classList.add("resultMessage");

				var container = document.createElement("div");
				container.appendChild(accountName);
				container.appendChild(message);
				
				r.insertBefore(container, r.firstChild);
			}
			fbtns = document.querySelectorAll('button[class="footerbtn"]');
			for (var i = fbtns.length - 1; i >= 0; i--)  {
				fbtns[i].style.display = 'flex';
			}
		}
		if (body.message == 'Error') {
			var message = document.createElement("span")
			
			if (Array.isArray(body.result)) {
				message.innerText = body.result[0].result;
			}
			else {
				message.innerText = body.result;
			}

			message.classList.add("resultAccountName");
			r.appendChild(message);

			renderRunBtn(false)
		}

		document.getElementById("results").style.background = "#FFFFFF";
	 })
	 .catch(error => {
	 	console.log(error);
	 })
} 

function renderRunBtn(runned){
	var rbtn = document.getElementById("runBtn");
  	var i = rbtn.getElementsByTagName('i')[0];

  	if (rbtn.disabled) {
  		rbtn.disabled = false;
  	}

  	i.className = "fas runIcon"
  	i.classList.add(runned ? 'fa-check' : runned==undefined ? 'fa-play' : 'fa-times');
  	rbtn.className = runned ? 'executedRun' :  runned==undefined ? 'normalRun' : 'erroredRun';
  	rbtn.children[1].textContent = runned ? 'Executed' : runned==undefined ? 'Run' : 'Failed!';
}

function rightsCheck(){
	return new Promise(function(resolve, reject) {
		var id = window.location.pathname.split('/');
		id = id[2];

		json = JSON.stringify({ 
			type : "accountCheck",
			id : id
		})
		serverRequest(json)
		 .then(funcs => {
		 	func_help = funcs;
			resolve();
		 })
		 .catch(error => {
		 	reject(error);
		 })
	})
}

function showPage(){
	var coll = document.getElementsByClassName("collapsible");
	var i;

	//left menu styling
	for (i = 0; i < coll.length; i++) {
		coll[i].addEventListener('click', function() {
			this.classList.toggle("active");
			cont = this.parentElement.parentElement.getElementsByClassName("content");

			for (var i=cont.length-1; i>=0; i--) {
				if (cont[i].style.maxHeight) {
					cont[i].style.maxHeight = null;
				} else {
					cont[i].style.maxHeight = cont[i].scrollHeight + "px";
				}
			}
		});
	}
	//hide loader
	document.getElementById('preloader').style.display = 'none';
	document.getElementById('addAccountBtns').style.display = 'flex';

	//hide account search results in searchTile 
	document.getElementById("searchTile").addEventListener('focusout', (event) => {
		if (event.relatedTarget) {}
		else{
	  		hideAccountSearchResults();
		}
	})

	//
	document.addEventListener('click', function(event) {
		var el = document.querySelectorAll('.active');
		if (el.length == 0) return;
		for (var i = el.length - 1; i >= 0; i--) {
			if (!el[i].contains(event.target)) {
				el[i].classList.toggle('active');
			}
		}
	})

	var select = document.querySelectorAll('input[name="acc_search_filter"]');
	for (var i = select.length - 1; i >= 0; i--) {
		select[i].addEventListener('click', makeSelectActive);
	}

	alert('Данная редакция продукта не предназначена для промышленной эксплуатации и может использоваться исключительно для целей тестирования вплоть до 31.10.2021');
}

function makeSelectActive(){
	this.parentNode.parentNode.parentNode.classList.toggle('active');
}

async function loadAccountsFromFile(file) {
	let text = await file.text();
    try{
    	var accounts = text.split('\n').slice(0, -1);
		var accField = document.getElementById("accountsList");

		addAccounts(accounts);
		addTag(file.name, accounts);
	}
    catch (e) {
    	alert(e);
    }
  }

var resView = null;
function loadResultsToViewer(){
	var content = document.getElementById("results").children;
	var targetContainer = resView.document.getElementById("results");

	for (var i = content.length - 1; i >= 0; i--) {
	  targetContainer.insertBefore(content[i], targetContainer.firstChild);
	}
}

function openResultsViewer() {
 	if(resView == null || resView.closed) {
		resView = window.open('results.wssp', 'Results');
		resView.addEventListener('DOMContentLoaded', loadResultsToViewer)
 	}
 	else {
 		resView.focus();	
 	}
}

function makeBold(input) {
    return input.replace(new RegExp('()__(.*)__()','ig'), '$1<b>$2</b>$3');
}

rightsCheck()
 .then(() => {
 	loadFunctions();
 	getDomains().then(() => {
		getGroups().then(groups => createGroupsList(groups));
	});
 	showPage();
 })
 .catch(error => {
	document.documentElement.remove();
	alert(error.statusText);}
 )